Codeforces Round #634 (Div. 3)

    题意:将n分成a,b。保证a>b,问有几种分法

    解析:偶数输出n/2-1,奇数n/2即可

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<set>
using namespace std;
typedef long long ll;
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        ll n;
        cin>>n;
        if(n%2==0)
            cout<<n/2-1<<endl;
        else
            cout<<n/2<<endl;
    }
}

    题意:输出一个长为n的字符串,要求a长度里有b个不同字母

     解析:其实弄来弄去还是只看一个len=a的串即可,比如abcabc,a=3, 从i=1到i=3和从i=2到i=4其实是同一个串而已,只是顺序不同罢了。所以根据要求构造成一个len=a,含有b个不同字符的串,然后把这个串依次往后接即可。自己写的有点麻烦......

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<set>
using namespace std;
typedef long long ll;
char ch[2005],s[2005];
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        int n,a,b;
        cin>>n>>a>>b;
        if(a==b)
        {
            int k=0;
            for(int i=0;i<n;i++)
            {
                char mid=(char)(k+‘a‘);
                k++;
                if(k==26)
                    k=0;
                cout<<mid;
            }
            cout<<endl;
        }
        else
        {
            int k=0;
            int cnt=0;
            int mid;
            char md;
            for(int i=0;i<a;i++)
            {
                ch[i]=(char)(k+‘a‘);
                cnt++;
                if(cnt==b)
                {
                    mid=i;
                    md=ch[i];
                    break;
                }
                k++;
            }
            for(int i=mid+1;i<a;i++)
                ch[i]=md;
            int tot=0;
            for(int i=0;i<n;i++)
            {
                cout<<ch[tot];
                tot++;
                if(tot==a-1)
                    tot=0;
            }
            cout<<endl;
        }
    }
}

    题意:在一个数组中挑些数分成两组,一组各不相等,一组全相等。

     解析:先统计出两个值,cnt:有多少种数。maxx:出现次数最多的数。然后把cnt--,这个cnt就是除了maxx以外有多少种数了。

        然后分情况:1:cnt==maxx,没得说,直接输出cnt

              2:maxx<cnt。没法进行补救,一组全相等我最大也就分出maxx,没法进行补救措施。这里给出样例:2 2 2 3 3 4 7 8 9供测试证明。

              3:maxx>cnt。是有可能进行补救的。因为cnt是不包含maxx的,所以可以从maxx挪出来一个放入cnt中,但是要保证两组的元素数目相同,所以要看看maxx-1和cnt+1的大小关系。如果cnt+1>maxx-1了,那肯定是不能往里补的,只能输出cnt。能补的话,就输出cnt+1。给出两个样例:1 2 4 4 4 4 3和2 2 2 2 2  7 4。这俩一个能补一个不能补,可以自行测试一下。

#include<iostream>
#include<cstdio>
#include<cmath>
#include<map>
#include<algorithm>
#include<cstring>
using namespace std;
typedef long long ll;
const int maxn=2e5+10;
int a[maxn];
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        int n;
        cin>>n;
        map<int,int>mp;
        int maxx=-1,cnt=0;
        for(int i=0;i<n;i++)
        {
            cin>>a[i];
            if(mp[a[i]]==0)
                cnt++;
            mp[a[i]]++;
            maxx=max(maxx,mp[a[i]]);
        }
        cnt--;
    //    cout<<cnt<<"--"<<maxx<<endl;
        if(maxx==cnt)
        {
            cout<<maxx<<endl;
            continue;
        }
        else if(maxx<cnt)
        {
            cout<<maxx<<endl;
        }
        else
        {
            if(cnt+1>maxx-1)
                cout<<cnt<<endl;
            else
                cout<<cnt+1<<endl;
        }
    }
}

    题意:给你一个正确的9*9数独矩阵。对它改动不超过9次来实现每行每列每3*3都要有至少两个元素相同。

     解析:这个重在对题意的理解。可以看出,给出的一定是每行每列每3*3都没有重复元素的。所以要让它变成反数独矩阵,只需要任意找一个数x,把所有的x变成y(x!=y)就可以了。这样,保证了每行每列都有重复元素,而对于3*3,已知输入的3*3里一定没有重复元素,那么1-9都出现在了3*3里,我们把x变成y,一定会出现重复。

#include<bits/stdc++.h>
using namespace std;
const int maxn=10;
char s[maxn][maxn];
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        for(int i=0;i<9;i++)
            cin>>s[i];
        for(int i=0;i<9;i++)
        {
            for(int j=0;j<9;j++)
            {
                if(s[i][j]==‘3‘)
                    s[i][j]=‘4‘;
            }
        }
        for(int i=0;i<9;i++)
            cout<<s[i]<<endl;
    }
}

            

原文地址:https://www.cnblogs.com/liyexin/p/12700774.html

时间: 2024-08-01 17:26:25

Codeforces Round #634 (Div. 3)的相关文章

Codeforces Round #634 (Div. 3) 补题

A. Candies and Two Sisters 签到题,直接输出即可 代码 #include<bits/stdc++.h> #define INF 0x3f3f3f3f typedef long long ll; using namespace std; inline void read(int &p) { p=0;int flag=1;char c=getchar(); while(!isdigit(c)) {if(c=='-') flag=-1;c=getchar();} w

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f

Codeforces Round #315 (Div. 1)

A. Primes or Palindromes? time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Rikhail Mubinchik believes that the current definition of prime numbers is obsolete as they are too complex and un

DP Codeforces Round #303 (Div. 2) C. Woodcutters

题目传送门 1 /* 2 题意:每棵树给出坐标和高度,可以往左右倒,也可以不倒 3 问最多能砍到多少棵树 4 DP:dp[i][0/1/2] 表示到了第i棵树时,它倒左或右或不动能倒多少棵树 5 分情况讨论,若符合就取最大值更新,线性dp,自己做出来了:) 6 */ 7 #include <cstdio> 8 #include <algorithm> 9 #include <cstring> 10 #include <cmath> 11 #include &